import java.util.*;
public class Listenverwalter {
  private int zaehler = 0;
  private List<Integer> testListe;

  public Listenverwalter() {
    testListe = new List<Integer>();
    zaehler = 0;
  }

  public void erzeugeBeispielliste() {
    zaehler = 0;
    testListe = new List<Integer>();
    testListe.append(new Integer(25));
    testListe.append(new Integer(17));
    testListe.append(new Integer(32));
    testListe.append(new Integer(56));
    testListe.append(new Integer(26));
    testListe.append(new Integer(19));
    testListe.append(new Integer(8));
    testListe.append(new Integer(66));
    testListe.append(new Integer(29));
    testListe.append(new Integer(6));
    testListe.append(new Integer(20));
    testListe.append(new Integer(27));    
  }

  private void zaehle() {
    zaehler ++;
  }

  public int anzahlVergleiche() {
    return zaehler;
  }

public void sortiere1() {
  // Straight Insertion
  List<Integer> hilfsliste = new List<Integer>();         
  while (!testListe.isEmpty()) {
    testListe.toFirst();
    Integer aktueller = testListe.getContent();
    testListe.remove();
    hilfsliste.toFirst();
    boolean gefunden = false;
    while (!gefunden && hilfsliste.hasAccess()) {
      if (aktueller.intValue() < hilfsliste.getContent().intValue()) {
        gefunden = true;
      } else {
        hilfsliste.next();
      }
      zaehle();
    }
    if (hilfsliste.hasAccess()) {
      hilfsliste.insert(aktueller);
    } else {
      hilfsliste.append(aktueller);
    }
  }
  testListe.concat(hilfsliste);
}

public void sortiere2() {
  // Quicksort
  testListe = quicksort(testListe);
}

private List<Integer> quicksort(List<Integer> pListe) {
  List<Integer> ergebnis = new List<Integer>();
  if (!pListe.isEmpty()) {
    pListe.toFirst();
    Integer pivot = pListe.getContent();
    pListe.remove();
    List<Integer> kleiner = new List<Integer>();
    List<Integer> groesser = new List<Integer>();
    while (!pListe.isEmpty()) {
      Integer aktuelles = pListe.getContent();
      if (aktuelles.intValue() < pivot.intValue()) {
        kleiner.append(aktuelles);
      } else {
        groesser.append(aktuelles);
      }
      zaehle();
      pListe.remove();
    }
    kleiner = quicksort(kleiner);
    groesser = quicksort(groesser);
    ergebnis = kleiner;
    ergebnis.append(pivot);
    ergebnis.concat(groesser);     
  }
  return ergebnis;
}

  public void testeAlgorithmen() {
    System.out.println("StraightInsertion Quicksort Beispielliste");
    erzeugeBeispielliste();
    sortiere1();
    int anz1 = anzahlVergleiche();
    erzeugeBeispielliste();
    sortiere2();
    int anz2 = anzahlVergleiche();
    System.out.println("12"+"\t\t"+anz1+"\t\t"+anz2);
  } 

}

